/***************************************************************************
 *   Copyright (C) 2010 by Ahsan Tariq   *
 *   ahsan@mpi-sws.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <iostream>
#include <fstream>
#include <string>
#include <cstring>

class cRIB;
class cRIBdualNH;

class cRouteProcessor
{
 public:
  cRouteProcessor(std::string& RTFile, std::string& updateFile);
  
  // open (or close) the routing table file RT
  // int SetRoutingTable (std::string *RT);
  // void ResetRoutingTable();
  
  // open (or close) the update file UPFile
  // int SetUpdateFile (std::string *UPFile);
  void resetUpdateFile();

  // Read entire Routing table
  int ReadRoutingTable(cRIB& RIB);
  
  // Read next num updates. -1 means read till end
  unsigned int ReadUpdateFile(cRIB& RIB, int numUpdToBeRead=-1);
  
  // Read entrire routing table
  int ReadRoutingTable(cRIBdualNH& RIB);
  
  // read next num updatres. -1 means read till end
  unsigned int ReadUpdateFile(cRIBdualNH& RIB, int numUpdToBeRead=-1);
  
 private:
  int numEntriesReadFromRT;
  int numUpdatesRead;
  std::string RTFilename;
  std::string updateFilename;
  std::ifstream updateFileStream;
};

